with Interfaces; use Interfaces;

package body CosNotifyChannelAdmin_ConsumerAdmin_Hash is

   P : constant array (0 .. 6) of Natural :=
     (1, 2, 4, 5, 9, 10, 23);

   T1 : constant array (0 .. 6) of Unsigned_8 :=
     (44, 48, 21, 45, 41, 34, 35);

   T2 : constant array (0 .. 6) of Unsigned_8 :=
     (6, 11, 34, 40, 27, 57, 8);

   G : constant array (0 .. 58) of Unsigned_8 :=
     (0, 0, 23, 0, 0, 0, 10, 0, 9, 18, 21, 6, 0, 3, 0, 0, 0, 1, 0, 1, 0, 0,
      0, 0, 5, 0, 0, 0, 18, 3, 16, 13, 0, 1, 0, 25, 0, 8, 0, 10, 0, 21, 17,
      0, 24, 11, 0, 0, 0, 0, 28, 0, 15, 18, 0, 28, 2, 0, 3);

   function Hash (S : String) return Natural is
      F : constant Natural := S'First - 1;
      L : constant Natural := S'Length;
      F1, F2 : Natural := 0;
      J : Natural;
   begin
      for K in P'Range loop
         exit when L < P (K);
         J  := Character'Pos (S (P (K) + F));
         F1 := (F1 + Natural (T1 (K)) * J) mod 59;
         F2 := (F2 + Natural (T2 (K)) * J) mod 59;
      end loop;
      return (Natural (G (F1)) + Natural (G (F2))) mod 29;
   end Hash;

end CosNotifyChannelAdmin_ConsumerAdmin_Hash;
